#ifndef TIMER_H
#define TIMER_H

#include <stdint.h>	

#ifdef __linux__
	#include <time.h>
#endif



typedef struct
{
	uint8_t day;
	uint8_t month;
	uint16_t year;
	uint32_t sec;
	uint32_t usec;
} date_t;

void 			timer_init();
uint64_t 	get_time_us();
void 			set_delta();
uint64_t 	get_delta();
void 			micro_sleep(unsigned long x);
unsigned long time_micros();
#endif
